addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "king" or p.mo.skin == "faker" or p.mo.skin == "freezer" or p.mo.skin == "billy" or p.mo.skin == "funky"

		if p.mo.state == S_PLAY_FLY
			P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
		end

		if (P_IsObjectOnGround(p.mo))
			if p.mo.skin == "king" and (p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_DASH) and not (p.powers[pw_super] > 0)
				P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
			end
			if (p.mo.skin == "freezer" or p.mo.skin == "billy") and p.mo.state == S_PLAY_RUN
				P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
			end
			if (p.mo.skin == "faker" or p.mo.skin == "funky") and (p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_DASH)
				P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
			end
			if p.mo.state == S_PLAY_ROLL
				P_SpawnSkidDust(p, 13*FRACUNIT, sfx_none)
			end
		end

		if p.dashmode > 3*TICRATE or p.mo.state == S_PLAY_NIGHTS_DRILL or p.mo.state == S_PLAY_ROLL or p.mo.state == S_PLAY_FLOAT or p.mo.state == S_PLAY_FLOAT_RUN or p.mo.state == S_PLAY_FLY or p.powers[pw_super] > 0
			local ghost = P_SpawnGhostMobj(p.mo)
			ghost.fuse = 4
		end
	end
end)

addHook("AbilitySpecial", function(p)
	if p.mo and (p.mo.skin == "king" and not (p.powers[pw_super] > 0) and not (p.pflags & PF_THOKKED)) or p.mo.skin == "billy" then
		for i = 0, 8
			local fa = (i*(ANGLE_180/4))
			local spark = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
			spark.momx = FixedMul(sin(fa),0*FRACUNIT)
			spark.momy = FixedMul(cos(fa),0*FRACUNIT)
		end
	end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.skin == "funky" and (p.mo.state == S_PLAY_FLY) and leveltime % 3 == 0 then
        for i = 0, 8
            local fa = (i*(ANGLE_180/4))
            local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
            dust.momx = FixedMul(sin(fa),1*FRACUNIT)
            dust.momy = FixedMul(cos(fa),1*FRACUNIT)
			dust.fuse = 35*FRACUNIT/4
        end
    end
end)

addHook("AbilitySpecial", function(p)
	if (p.mo and p.mo.skin == "faker") and ((p.charflags & SF_MULTIABILITY) or not (p.pflags & PF_THOKKED)) then
		for i = 0, 8
            local fa = (i*(ANGLE_180/4))
            local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
            dust.momx = FixedMul(sin(fa),10*FRACUNIT)
            dust.momy = FixedMul(cos(fa),10*FRACUNIT)
        end
	end
end)

addHook("PlayerThink", function(p)
    if p.mo and ((p.mo.skin == "king" and (p.powers[pw_super] > 0)) or (p.mo.skin == "billy" and p.dashmode > 3*TICRATE)) and leveltime % 3 == 0 then
        for i = 0, 8
			local fa = (i*(ANGLE_180/4))
			local spark = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SUPERSPARK)
			spark.momx = FixedMul(sin(fa),0*FRACUNIT)
			spark.momy = FixedMul(cos(fa),0*FRACUNIT)
		end
    end
end)